bdi4jade.core

## Class GoalUpdateSet

- java.lang.Object
- - bdi4jade.core.GoalUpdateSet

-     public class GoalUpdateSet
      extends java.lang.Object

  This class is a data structure to used to specify updates on goals. In a certain agent state, it has a set of current goals. During the agent reasoning cycle, some of these goals may be dropped, and new goals may be generated. This class has the set with current goals, and allows informing which goals should be dropped, and which should be generated. Current goals may contain goals dispatched by a single capability.
  Author:
    Ingrid Nunes

- - ### Nested Class Summary

    Nested Classes
    Modifier and Type | Class and Description
    --- | ---
    `class` | `GoalUpdateSet.GoalDescription` This class is a data structure to describe a goal.

  - ### Method Summary

    All Methods Instance Methods Concrete Methods
    Modifier and Type | Method and Description
    --- | ---
    `void` | `dropGoal(GoalUpdateSet.GoalDescription goal)` Indicates that a goal should be dropped.
    `void` | `generateGoal(Goal goal)` Indicates that a goal should be added to the agent.
    `void` | `generateGoal(Goal goal, Capability dispatcher)` Indicates that a goal should be added to the agent, with the capability that dispatched the goal.
    `void` | `generateGoal(Goal goal, Capability dispatcher, GoalListener listener)` Indicates that a goal should be added to the agent, with the capability that dispatched the goal and provided listener.
    `void` | `generateGoal(Goal goal, GoalListener listener)` Indicates that a goal should be added to the agent, with the provided listener.
    `java.util.Set<GoalUpdateSet.GoalDescription>` | `getCurrentGoals()` Returns the set of current agent goals.
    `java.util.Set<GoalUpdateSet.GoalDescription>` | `getDroppedGoals()` Returns the set of dropped goals.
    `java.util.Set<GoalUpdateSet.GoalDescription>` | `getGeneratedGoals()` Returns the set of generated goals.

    - ### Methods inherited from class java.lang.Object

      `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- - ### Method Detail

    - #### dropGoal

          public void dropGoal(GoalUpdateSet.GoalDescription goal)

      Indicates that a goal should be dropped. The goal is added to the set of dropped goals.
      Parameters:
        `goal` - the goal to be dropped.

    - #### generateGoal

          public void generateGoal(Goal goal)

      Indicates that a goal should be added to the agent. The goal is added to the set of generated goals.
      Parameters:
        `goal` - the goal to be added.

    - #### generateGoal

          public void generateGoal(Goal goal,
                                   Capability dispatcher)

      Indicates that a goal should be added to the agent, with the capability that dispatched the goal. The goal is added to the set of generated goals.
      Parameters:
        `goal` - the goal to be added.
        `dispatcher` - the capability that dispatched the goal.

    - #### generateGoal

          public void generateGoal(Goal goal,
                                   Capability dispatcher,
                                   GoalListener listener)

      Indicates that a goal should be added to the agent, with the capability that dispatched the goal and provided listener. The goal is added to the set of generated goals.
      Parameters:
        `goal` - the goal to be added.
        `dispatcher` - the capability that dispatched the goal.
        `listener` - a goal listener.

    - #### generateGoal

          public void generateGoal(Goal goal,
                                   GoalListener listener)

      Indicates that a goal should be added to the agent, with the provided listener. The goal is added to the set of generated goals.
      Parameters:
        `goal` - the goal to be added.
        `listener` - a goal listener.

    - #### getCurrentGoals

          public java.util.Set<GoalUpdateSet.GoalDescription> getCurrentGoals()

      Returns the set of current agent goals.
      Returns:
        the set of current goals.

    - #### getDroppedGoals

          public java.util.Set<GoalUpdateSet.GoalDescription> getDroppedGoals()

      Returns the set of dropped goals.
      Returns:
        the set of dropped goals.

    - #### getGeneratedGoals

          public java.util.Set<GoalUpdateSet.GoalDescription> getGeneratedGoals()

      Returns the set of generated goals.
      Returns:
        the set of generated goals.